package refactor;



/**
 * Dieses Interface charakterisiert ein Objekt einer Klasse, das dieses
 * Interface implementiert, als Deklaration.
 * <p>
 * Eine Deklaration kann sich in einem {@link Scope} befinden.
 * 
 * @see #getContext()
 * @see #setContext(Scope))
 * @layer typesys
 * @author Stephan Klapproth
 * 
 */
public interface Declaration extends Named {

    /**
     * Gibt den Scope zurck, in dem die Deklaration auftaucht.
     * 
     * @return Scope.
     * @see Scope
     */
    public Scope getContext();

    /**
     * Setzt den Scope der Deklaration.
     * 
     * @param aScope Scope.
     */
    public void setContext(Scope aScope);

}
