package refactor;



class VariableReferenceConflict extends Conflict {

    private FieldAccess access;

    private FieldInfo field;

    public VariableReferenceConflict(FieldAccess anAccess) {
        super();
        access = anAccess;
        field = anAccess.getField();
    }

    public String getDescription() {
        return "Within statements declared temporary variable " + field.getName() +
        		" is referenced afterwards, and therefore can not be extracted.";	
    }

    public int startLine() {
        return access.startLineNum();
    }

    public int endLine() {
        return access.endLineNum();
    }

    public String getFile() {
        return ((ClassInfoAst) TypesysUtil.getDeclaringClass(access))
                .getSrcFile().getAbsolutePath();
    }
}
